// cutscene.h
// Simple cutscene generator.
// From Goku Mal

// do_cutscene takes two parameters: first and last cutscene text portion to show.
// each text portion is a string (@ within a string is a line break) and is
// printed alongside a picture stored in the resource library.
// Text portion N will show picture BASE_PIC_RESOURCE + N.

#define CUTSCENE_X				4		// Top-left X coordinate of text.
#define CUTSCENE_Y 				13		// "   "    Y "          "  "
#define BASE_PIC_RESOURCE 		11		// Pic resources start here
#define cutscene_TEXT_COLOUR	71		// Text colour.
#define SCREEN_WAIT				250		// halts to wait after showing a screen.
#define LANG_TEXT_OFFS			16		// Add to message for second language text.

extern unsigned char cutscene_text_1 [0];
extern unsigned char cutscene_text_2 [0];
extern unsigned char cutscene_text_3 [0];
extern unsigned char cutscene_text_4 [0];
extern unsigned char cutscene_text_5 [0];
extern unsigned char cutscene_text_6 [0];
extern unsigned char cutscene_text_7 [0];
extern unsigned char cutscene_text_8 [0];


char *eraseline = "                            ";

unsigned char *cutscene_script [] = {
	// Offset == 0
	0, s_plate_1, cutscene_text_1, cutscene_text_2, 0, s_plate_2, cutscene_text_3, cutscene_text_4,
	// Offset == 8
	0, s_plate_3, cutscene_text_5, cutscene_text_6, 0, s_plate_4, cutscene_text_7, cutscene_text_8
};

#asm
	._cutscene_text_1
		defm "I'M ALASTOR DE LA BABUCHA@THE EVIL DUKE-MARQUIS@FROM FREEZIA & FRIDGELAND@(PROVINCE OF BADAJOZ)"
		defb 0
	._cutscene_text_2
		defm "'I JUST ABDUCTED YOU!@I NEED THE PRINCE JUICE@WHICH CAN BE EXTRACTED@FROM OUR PRINCELY BODIES,'"
		defb 0
	._cutscene_text_3
		defm "'SO I WILL TURN YOU INTO@UGLY. FIENDISH BATS.@HAIRY AND DISGUSTING.@SMELLY AND DIRTY,'"
		defb 0
	._cutscene_text_4
		defm "'AND I WILL PLACE THOU@OVER THE 6 TOWERS@IN MY ICE PALACE@SO YOU CAN HOVER AROUND'"
		defb 0
	._cutscene_text_5
		defm "'SIR ABABOL! YOU RUINED@MY PERFECT PLANS!@WHY DIDN'T YOU JUST@STAY AT HOME?!'"
		defb 0
	._cutscene_text_6
		defm "'HAVE THIS! FEEL MY@SWORDY SWORD ON YOUR BONG!'@ONCE AGAIN. SIR ABABOL@MADE THE GRADE!"
		defb 0
	._cutscene_text_7
		defm "'STOP COCKING AROUND!@AND QUICK!@GET ON MY FLYIN' CAR!@GOING BACK TO THE FUTURE!"
		defb 0
	._cutscene_text_8
		defm "'BUT WHAT 'BOUT MY HORSE?'@ASKED SIR ABABOL@'WHERE WE ARE GOING,,,@YOU NEED NO HORSE,,,'"
		defb 0
#endasm

unsigned char cutscenex, cutsceney, stepbystep, character;
void show_cutscene_text (unsigned char *s) {
	cutscenex = CUTSCENE_X;
	cutsceney = CUTSCENE_Y;
	stepbystep = 1;
	while (*s) {
		character = (*s ++);
		if (character != '@') 
			cpc_PutTile2x8 (
				(unsigned int *) (tile_0 + ((character - 32) << 4)),
				(unsigned char *) (8 + (cutscenex << 1)),
				(unsigned char *) (4 + (cutsceney << 3))
			); cutscenex ++;
		if (stepbystep) {
			wait_a_bit (4);
			if (cpc_TestKey (KEY_FIR)) stepbystep = 0;
		}
		if (character == '@') {cutsceney += 2; cutscenex = CUTSCENE_X;}
	}
	if (!stepbystep) {
		
	}
}

unsigned char cutscene_iterator, lineeraser;
void do_cutscene (unsigned char ini, unsigned char fin) {
	unsigned char text_offs = LANG_TEXT_OFFS * language;
	for (cutscene_iterator = ini; cutscene_iterator <= fin; cutscene_iterator ++) {
		if (cutscene_script [cutscene_iterator + text_offs] == 0) {
			cutscene_iterator ++;
			
			//blackout_area ();
			//get_resource ((unsigned char) (cutscene_script [cutscene_iterator + text_offs]), 16384);
			cpc_UnExo ((unsigned int *) (cutscene_script [cutscene_iterator + text_offs]), (unsigned int *) (0xc000));
		} else {
			show_cutscene_text (cutscene_script [cutscene_iterator + text_offs]);
			wait_a_bit (SCREEN_WAIT);
			while (cpc_TestKey (KEY_FIR));
			for (lineeraser = CUTSCENE_Y; lineeraser < CUTSCENE_Y + 8; lineeraser ++) {
				print_str (CUTSCENE_X, lineeraser, 71, eraseline);
				
				wait_a_bit (4);
			}
		}
	}
	blackout_area ();	
}
