// definitions.h

// Defines
#define sgni(n)			(n < 0 ? -1 : 1)

#define EST_NORMAL 				0
#define EST_PARP 				2
#define EST_MUR 				4
#define EST_ICE					8
#define EST_PARALYZED			16
#define EST_STOP				32

#define SWORD_TYPE_LEFT			1
#define SWORD_TYPE_RIGHT		2
#define SWORD_TYPE_UP			3

#define MAX_BREAKABLE			2
#define MAX_BREAKABLE_FRAMES 	6

// Structs
typedef struct {
	signed int x, y;
	unsigned char x1, y1, x2, y2;
	signed char mx, my;
	signed char t;
} MALOTE;

// Enemies
unsigned char en_an_frame [3];
unsigned char en_an_count [3], en_an_st_counter [3];
unsigned char *en_an_current_frame [3], *en_an_next_frame [3], *en_an_base_frame [3];
unsigned char en_an_morido [3];
signed int en_an_x [3];
signed int en_an_y [3];
signed int en_an_vx [3];
signed int en_an_vy [3];
unsigned char en_an_fanty_activo [3];
unsigned char en_an_state [3];
unsigned char en_an_s [3];

// Player
signed int p_x, p_y, p_cx;
signed int p_vx, p_vy;
signed char p_g, p_ax, p_rx, p_axf, p_rxf;
unsigned char p_salto, p_cont_salto;
unsigned char *p_current_frame, *p_next_frame;
unsigned char p_saltando;
unsigned char p_frame, p_subframe, p_facing;
unsigned char p_state;
unsigned char p_counter;
unsigned char p_gotten;
unsigned char p_life, p_objs, p_keys, p_score;
unsigned char o_life, o_keys, o_score;
unsigned char p_swording;
unsigned char p_px, p_py;
unsigned char p_incr_salto;
unsigned char p_stop;

// Sword
unsigned char s_on;
unsigned char s_type;	
unsigned char s_frame;
signed int s_x, s_y;
unsigned char *s_current_frame, *s_next_frame;

// breakable
unsigned char b_x [MAX_BREAKABLE], b_y [MAX_BREAKABLE], b_f [MAX_BREAKABLE];

// Globals
// (CPC)

struct sprite { 			// estructura mnima para usar la librera de dibujar sprites capturando el fondo.
	int sp0;				// 2 bytes	01
	int sp1;				// 2 bytes	23
	int coord0; 			// 2 bytes	45	 posicin en superbuffer
	int coord1; 			// 2 bytes	67	 posicin anterior en superbuffer
	unsigned char cx, cy;	// 2 bytes	89	 coordenadas nuevas
	unsigned char ox, oy;	// 2 bytes	AB	 coordenadas actuales
	unsigned char move; 	// 1 byte	 C	  si NO es 0, el sprite se mueve.
	unsigned char move1;	// 1 byte	 D	  si NO es 0, el sprite se mueve.
	// Si es 8 en cuanto se mueva se pone a 0 y ya no se mueve ms hasta nueva orden.
};

struct sprite sp_player;
struct sprite sp_enem1;
struct sprite sp_enem2;
struct sprite sp_enem3;
struct sprite sp_sword;

extern unsigned char tile_0 []; // Tiles en tilemapconf

// EOFCPC

extern unsigned int seed1 [0];
extern unsigned int seed2 [0];
extern unsigned char randres [0];
extern unsigned char asm_number [0];
extern unsigned int asm_int [0];

unsigned char half_life = 0;
unsigned char enoffs;

#asm
	._seed1			defw 0
	._seed2			defw 0
	._randres		defb 0
	._asm_number	defb 0
	._asm_int		defw 0
#endasm


// Super globals! More global than globals.
// Globals with PODEWWWR!!!
unsigned char men [60];

// Those are made global to try and gain some speed

unsigned char px, py, pxx, pyy, pax, prx;
unsigned char gpx, gpy, gpt, gpc;
unsigned char *map_pointer;
unsigned char hpx, hpy;
unsigned char joybar; 
unsigned char ccx, ccy;
unsigned char eni, enj;
unsigned char exx, eyy;
unsigned char enoffsmasi;
unsigned char tget;
unsigned char it, jt;
signed int maxx;
signed int tindex;
unsigned char joystick_control;

unsigned char *str_level = "LEVEL 0X";

unsigned int key_1, key_2, key_3, key_space, key_s;
unsigned char up = 0;
unsigned char level;

unsigned char language;

// Teclas para el manejador de CPCRSLIB
#define KEY_IZQ 		0
#define KEY_DER 		1
#define KEY_ARR 		2
#define KEY_SAL 		3
#define KEY_FIR 		4
#define KEY_ESC 		5
#define KEY_ENTER 		6

#define WYZ_CANAL_EFECTOS 1