// mysystem.h
/*
	Estas eran las paletas originales con los nmeros de firmware.
	Las he tenido que transformar en paletas hardware por el tema
	de las interrupciones.

	Tabla de conversin de paletas
	
	firm	hard
	0		20
	1		4
	2		21
	3		28
	4		24
	5		29
	6		12
	7		5
	8		13
	9		22
	10		6
	11		23
	12		30
	13		0
	14		31
	15		14
	16		7
	17		15
	18		18
	19		2
	20		19
	21		26
	22		25
	23		27
	24		10
	25		3
	26		11
*/
// 0 11 23 26 -> 20 23 27 11
unsigned char my_inks [] = {
	20, 23, 27, 11
};
void set_inks () {
	unsigned char i;
	for (i = 0; i < 4; i ++)
		cpc_SetColour (i, my_inks [i]);
}

void halt_me (void) {
	#asm
		halt				;unas esperas para que se actualicen los colores
		halt
		halt
		halt
		halt
	#endasm
}

void interrupciones(void) {
	// Manejador de interrupciones por Artaburu
	#asm
		di
		ld hl,($0039)
		ld (_int_original),HL   //guardo el salto original

		ld HL,_interrupcion
		ld ($0039),HL
		ei
		jp term
	._int_original  
		defw 0
	._interrupcion
		ei
		ret
	.term
	#endasm
}

void init_cpcrslib_system () {
	interrupciones ();
	halt_me ();

	set_inks ();
	halt_me ();
	cpc_SetMode (1);
		
	// Inicializamos el player de wyz:
	
	cpc_WyzInitPlayer ((int) wyz_sound_table, (int) wyz_pattern_table, (int) wyz_effects_table, (int) wyz_song_table);
	
	// Batera por el canal que sea
	
	cpc_WyzConfigurePlayer (2);		
	
	// Borde 
	
	cpc_SetColour (16, 20);

	// Redefinimos las teclas
	
	cpc_AssignKey (KEY_IZQ, 0x4820);		// A
	cpc_AssignKey (KEY_DER, 0x4720);		// D
	cpc_AssignKey (KEY_ARR, 0x4708);		// W
	cpc_AssignKey (KEY_SAL, 0x4440);		// M
	cpc_AssignKey (KEY_FIR, 0x4540);		// N
	cpc_AssignKey (KEY_ESC, 0x4804);		// ESC
	cpc_AssignKey (KEY_ENTER, 0x4204);		// ENTER
}

void init_tileset () {

}

void init_sprites () {

}

void blackout () {

}
