// printer.h
// Especial para las versiones de 48K y CPC: un fondo tileado

unsigned char st_index;
unsigned char *st_pointer;
unsigned char tl_x, tl_y;

void draw_map_tile (unsigned char x, unsigned char y, unsigned char t) {

	st_index = 64 + (t << 2);
	x = (x << 1);
	y = (y << 1);
	
	cpc_SetTile (x, y, st_index ++);
	cpc_SetTile (x + 1, y, st_index ++);
	cpc_SetTile (x, y + 1, st_index ++);
	cpc_SetTile (x + 1, y + 1, st_index);
}

void draw_map_tile_inv (unsigned char x, unsigned char y, unsigned char t) {
	
	st_index = 64 + (t << 2);
	x = (x << 1);
	y = (y << 1);
	
	cpc_SetTouchTileXY (x, y, st_index ++);
	cpc_SetTouchTileXY (x + 1, y, st_index ++);
	cpc_SetTouchTileXY (x, y + 1, st_index ++);
	cpc_SetTouchTileXY (x + 1, y + 1, st_index);
}

void print_number2 (unsigned char x, unsigned char y, unsigned char number) {
	cpc_PutTile2x8 (
		(unsigned int *) (tile_0 + ((16 + (number / 10)) << 4)),
		(unsigned char *) (8 + (x << 1)),
		(unsigned char *) (4 + (y << 3))
	);
	
	cpc_PutTile2x8 (
		(unsigned int *) (tile_0 + ((16 + (number % 10)) << 4)),
		(unsigned char *) (8 + (x << 1) + 2),
		(unsigned char *) (4 + (y << 3))
	);
}

void print_number3 (unsigned char x, unsigned char y, unsigned char number) {
	cpc_PutTile2x8 (
		(unsigned int *) (tile_0 + ((16 + (number / 100)) << 4)),
		(unsigned char *) (8 + (x << 1)),
		(unsigned char *) (4 + (y << 3))
	);
	
	cpc_PutTile2x8 (
		(unsigned int *) (tile_0 + ((16 + ((number % 100) / 10)) << 4)),
		(unsigned char *) (8 + (x << 1) + 2),
		(unsigned char *) (4 + (y << 3))
	);
	
	cpc_PutTile2x8 (
		(unsigned int *) (tile_0 + ((16 + (number % 10)) << 4)),
		(unsigned char *) (8 + (x << 1) + 4),
		(unsigned char *) (4 + (y << 3))
	);
}

void print_str (unsigned char x, unsigned char y, unsigned char c, unsigned char *s) {
	while (gpc = *s ++)	{
		cpc_PutTile2x8 (
			(unsigned int *) (tile_0 + ((gpc - 32) << 4)),
			(unsigned char *) (8 + (x << 1)),
			(unsigned char *) (4 + (y << 3))
		);
		x ++;
	}
}

void blackout_area (void) {
	gpx = gpy = 0;
	for (it = 0; it < 150; it ++) {
		draw_map_tile (gpx, gpy, 0);
		gpx ++;
		if (gpx == 15) {
			gpy ++;
			gpx = 0;
		}
	}
	cpc_ResetTouchedTiles ();	
	cpc_ShowTileMap (0);
}
