// mysystem.h

unsigned char my_inks [] = {
	20, 4, 21, 23, 27, 11, 3, 14,
	5, 12, 24, 28, 0, 22, 26, 7
};
void set_inks () {
	unsigned char i;
	for (i = 0; i < 16; i ++)
		cpc_SetColour (i, my_inks [i]);
}

void halt_me (void) {
	#asm
		halt				;unas esperas para que se actualicen los colores
		halt
		halt
		halt
		halt
	#endasm
}

void interrupciones(void) {
	// Manejador de interrupciones por Artaburu
	#asm
		di
		ld hl,($0039)
		ld (_int_original),HL   //guardo el salto original

		ld HL,_interrupcion
		ld ($0039),HL
		ei
		jp term
	._int_original  
		defw 0
	._interrupcion
		ei
		ret
	.term
	#endasm
}

void init_cpcrslib_system () {
	interrupciones ();
	halt_me ();

	set_inks ();
	halt_me ();
	cpc_SetMode (0);
		
	// Inicializamos el player de wyz:
	
	cpc_WyzInitPlayer (wyz_sound_table, wyz_pattern_table, wyz_effects_table, wyz_song_table);
	
	// Batera por el canal que sea
	
	cpc_WyzConfigurePlayer (WYZ_CANAL_EFECTOS);		
	
	// Borde 
	
	cpc_SetColour (16, 20);

	// Redefinimos las teclas
	
	cpc_AssignKey (KEY_IZQ, 0x4820);		// A
	cpc_AssignKey (KEY_DER, 0x4720);		// D
	cpc_AssignKey (KEY_ARR, 0x4708);		// W
	cpc_AssignKey (KEY_SAL, 0x4440);		// M
	cpc_AssignKey (KEY_FIR, 0x4540);		// N
	cpc_AssignKey (KEY_ESC, 0x4804);		// ESC
	cpc_AssignKey (KEY_ENTER, 0x4204);		// ENTER
}

void init_tileset () {

}

void init_sprites () {
	// Initialize CPCRSLIB sprites
	
	sp_player.sp0 = (int) (spr_0);
	sp_player.sp1 = (int) (spr_0);
	sp_player.move = 0;
	sp_player.cx = sp_player.ox = (p_x >> 6) >> 2;
	sp_player.cy = sp_player.oy = (p_y >> 6);
	
	sp_enem1.sp0 = (int) (spr_8);
	sp_enem1.sp1 = (int) (spr_8);
	sp_enem1.move = 0;
	sp_enem1.cx = sp_enem1.ox = 0;
	sp_enem1.cy = sp_enem1.oy = 0;
	
	sp_enem2.sp0 = (int) (spr_8);
	sp_enem2.sp1 = (int) (spr_8);
	sp_enem2.move = 0;
	sp_enem2.cx = sp_enem2.ox = 0;
	sp_enem2.cy = sp_enem2.oy = 0;
	
	sp_enem3.sp0 = (int) (spr_8);
	sp_enem3.sp1 = (int) (spr_8);
	sp_enem3.move = 0;
	sp_enem3.cx = sp_enem3.ox = 0;
	sp_enem3.cy = sp_enem3.oy = 0;
	
	sp_sword.sp0 = (int) (spr_8);
	sp_sword.sp1 = (int) (spr_8);
	sp_sword.move = 0;
	sp_sword.cx = sp_sword.ox = 0;
	sp_sword.cy = sp_sword.oy = 0;
}

void blackout () {

}
