// Msica y sonidos Churrera CPC
// =============================

extern unsigned char wyz_sound_table [];
extern unsigned char wyz_pattern_table [];
extern unsigned char wyz_effects_table [];
extern unsigned char wyz_song_table [];
extern unsigned char song_0[];
extern unsigned char song_1[];
extern unsigned char song_2[];
extern unsigned char song_3[];
extern unsigned char song_4[];

// REMEMBER: Las canciones ms largas deben descomprimirse previamente
// sobre el buffer de tiles (en $100) - (ver wyz_song_table).

#asm
	._wyz_sound_table
				defw 	_sound0, _sound1, _sound2, _sound3
				defw 	_sound4, _sound5, _sound6, _sound7
				defw 	_sound8, _sound9
		
	._wyz_pattern_table
				defw	_pattern0
				defw	_pattern1, _pattern2, _pattern3, _pattern4
				defw	_pattern5, _pattern7, _pattern8
				defw	_pattern9, _pattern10, _pattern11, _pattern12
				defw	_pattern13, _pattern14, _pattern15, _pattern16
	
	._wyz_effects_table
				defw	_efecto0, _efecto1, _efecto2, _efecto3
				defw	_efecto4, _efecto5, _efecto6, _efecto7
				defw	_efecto8, _efecto9, _efecto10, _efecto11
	
	._wyz_song_table
				defw	$b400, $b400, $b400, $b400, $b400

; ***********************************************
;	Datos (sonidos, patrones, efectos y msicas)
; ***********************************************

; Sonidos (batera):
	;Efecto 'bass drum'
	._sound0	defb	209,61,0,15,124,0,255
	;Efecto 'bass drum vol 2'
	._sound1	defb	186,58,0,0,102,0,162,131,0,255
	;Efecto 'drum'
	._sound2	defb	231,46,0,115,43,1,100,42,2,255
	;Efecto 'drum 2'
	._sound3	defb	246,47,0,15,15,31,0,15,31,0,15,1,255
	;Efecto 'hithat'
	._sound4	defb	0,12,1,0,6,1,255
	;Efecto 'hit hat 2'
	._sound5	defb	0,12,1,255
	;Efecto 'Bongo 1'
	._sound6	defb	186,30,0,232,25,0,0,40,0,69,38,0,255
	;Efecto 'Bongo 2'
	._sound7	defb	69,46,0,186,41,0,46,56,0,232,54,0,255
	;Efecto 'drum 3'
	._sound8	defb	232,44,0,0,92,5,23,108,5,232,124,5,255
	;Efecto 'Lava 1'
	._sound9	defb	9,99,29,220,227,22,104,239,29,189,158,20,122,170,14,85,187,22,255
	
;Pautas (instrumentos)
	;Instrumento 'Piano'
	._pattern0	defb	8,0,7,0,6,0,8,0,129
	;Instrumento 'Piano Reverb'
	._pattern1	defb	10,0,11,0,10,0,9,0,8,0,8,0,8,0,8,0,8,0,8,0,7,0,7,0,7,0,7,0,136
	;Instrumento 'Fade In FX'
	._pattern2	defb	2,0,3,0,4,8,4,-1,5,-4,5,20,5,-24,4,4,132
	;Instrumento 'Guitar 1'
	._pattern3	defb	13,0,13,0,11,0,11,0,9,0,10,1,10,1,10,-1,10,-1,10,0,10,0,134
	;Instrumento 'Guitar 2'
	._pattern4	defb	13,0,13,0,12,0,11,0,9,0,8,1,8,0,8,0,8,-1,8,0,8,0,134
	;Instrumento 'Eco guitar'
	._pattern5	defb	7,0,7,0,7,0,6,0,6,0,6,0,6,0,6,0,5,0,5,0,5,0,5,0,5,0,4,0,4,0,4,0,4,0,3,0,0,0,129
	;Instrumento 'Solo Guitar'
	._pattern7	defb	75,0,10,0,10,0,10,0,9,0,14,1,14,0,14,-1,14,0,14,0,14,-1,14,0,14,1,14,1,14,0,138
	;Instrumento 'Eco Solo Guitar'
	._pattern8	defb	70,0,6,0,6,0,5,0,5,0,5,0,5,0,5,0,4,0,4,0,4,0,4,0,4,0,4,0,3,0,3,0,3,0,3,0,3,0,3,0,2,0,2,0,2,0,1,0,129
	;Instrumento 'Slap Bass'
	._pattern9	defb	46,0,12,4,11,-4,10,4,9,-5,8,0,129
	;Instrumento 'Robo'
	._pattern10	defb	7,-1,23,5,23,9,6,0,22,5,22,9,5,0,21,5,21,9,4,0,20,5,20,9,4,0,20,5,20,9,131
	;Instrumento 'Chip'
	._pattern11	defb	70,0,7,0,40,0,7,0,6,0,8,0,129
	;Instrumento 'Clipclop'
	._pattern12	defb	13,0,12,0,11,0,11,0,11,0,11,0,11,0,11,0,10,0,10,0,10,0,10,0,10,0,138
	;Instrumento 'Eco'
	._pattern13	defb	9,0,8,0,7,0,8,0,129	
	;Instrumento 'Harmonica'
	._pattern14	defb	42,0,11,0,12,0,11,0,10,0,4,0,129
	;Instrumento 'Onda'
	._pattern15	defb	73,0,10,0,11,0,12,0,11,0,10,0,9,0,9,0,129
	;Instrumento 'Teeth'
	._pattern16	defb	73,0,10,0,42,0,9,0,8,0,7,0,7,0,7,0,7,0,6,0,6,0,6,0,6,0,136
	
; Efectos de sonido:

; [0] Select
._efecto0		defb 	$51,$1A
				defb	$5A,$0F
				defb	$3C,$0F
				defb	$1E,$0E
				defb	$2D,$E
				defb	$5A,$0B
				defb	$3C,$0B
				defb	$1E,$0A
				defb	$2D,$0A
				defb	$B4,$01
				defb	$FF
				
; [1] Start
._efecto1		defb 	$25,$1C
				defb 	$3A,$0F
				defb	$2D,$0F
				defb	$E2,$0F
				defb	$BC,$0F
				defb	$96,$0D
				defb	$4B,$0D
				defb	$32,$0D
				defb 	$3A,$0D
				defb	$2D,$0D
				defb	$E2,$0D
				defb	$BC,$0D
				defb	$96,$0D
				defb	$4B,$0D
				defb	$32,$0D
				defb 	$3A,$0D
				defb	$2D,$0C
				defb	$E2,$0C
				defb	$BC,$0C
				defb	$96,$0B
				defb	$4B,$0B
				defb	$32,$0B
				defb 	$3A,$0B
				defb	$2D,$0B
				defb	$E2,$0B
				defb	$BC,$0B
				defb	$96,$0B
				defb	$4B,$0A
				defb	$32,$0A
				defb 	$3A,$0A
				defb	$2D,$09
				defb	$E2,$09
				defb	$BC,$08
				defb	$96,$08
				defb	$4B,$08
				defb	$32,$07
				defb 	$3A,$07
				defb	$2D,$06
				defb	$E2,$06
				defb	$BC,$06
				defb	$96,$05
				defb	$4B,$05
				defb	$32,$05
				defb 	$3A,$04
				defb	$2D,$04
				defb	$E2,$03
				defb	$BC,$03
				defb	$96,$03
				defb	$4B,$03
				defb	$32,$02
				defb 	$3A,$01
				defb	$2D,$01
				defb	$E2,$01
				defb	$BC,$01
				defb	$FF
				
; [2] Sartar
._efecto2		defb	$E8,$1B
				defb	$B4,$0F
				defb	$A0,$0E
				defb	$90,$0D
				defb	$87,$0D
				defb	$78,$0C	
				defb	$6C,$0B	
				defb	$60,$0A	
				defb	$5A,$09
				defb	$FF	
				
; [3] Disparo 1
._efecto3		defb	$1F,$0B
				defb	$5A,$0F
				defb	$3C,$0F
				defb	$1E,$0A
				defb	$2D,$0A
				defb	$5A,$05
				defb	$3C,$05
				defb	$1E,$04
				defb	$2D,$02
				defb	$B4,$01
				defb	$FF
	
; [4] Disparo 2
._efecto4		defb	$1F,$0B
				defb	$AF,$0F
				defb	$8A,$0F
				defb	$71,$0F
				defb	$64,$0F
				defb	$3E,$0C
				defb	$25,$0C
				defb	$25,$0C
				defb	$25,$0C
				defb	$25,$0A
				defb	$4B,$0A
				defb	$4B,$0A
				defb	$4B,$0A
				defb	$3E,$08
				defb	$3E,$08
				defb	$3E,$08
				defb	$71,$08
				defb	$3E,$07
				defb	$25,$05
				defb	$25,$02
				defb	$FF
				
; [5] Vida
._efecto5		defb	$1A,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E
				defb	$B4,$0E	
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$A0,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E
				defb	$87,$0E		
				defb	$78,$0E
				defb	$78,$0E
				defb	$78,$0D
				defb	$78,$0D
				defb	$78,$0D
				defb	$78,$0D
				defb	$78,$0D
				defb	$78,$0D
				defb	$78,$0C
				defb	$78,$09
				defb	$78,$06
				defb	$78,$05	
				defb	$FF
				
; [6] Dao Colision Disparo
._efecto6		defb 	$E8,$1B
				defb	$5F,$1F
				defb	$E2,$0F
				defb	$56,$3F
				defb	$F6,$1F
				defb	$14,$1E
				defb	$64,$0E	
				defb	$62,$3D
				defb	$D0,$1D
				defb	$F1,$2C
				defb	$FF	
				
; [7] Dao Colisin Enemigo
._efecto7		defb	$C3,$0E
				defb	$5F,$1F
				defb	$A6,$2F
				defb 	$E8,$1B
				defb 	$80,$2B
				defb	$FF
				
; [8] Puncho
._efecto8		defb 	$E8,$1B
				defb	$5F,$1F
				defb	$A6,$2F
				defb	$00,$00
				defb 	$80,$0F
				defb	$FF	

; [9] Coger tesoro
._efecto9		defb	$1F,$0B
				defb	$1A,$0C
				defb	$1F,$0D
				defb	$16,$0E
				defb	$1F,$0E
				defb	$0D,$0D
				defb	$1F,$0C
				defb	$0D,$0B
				defb	$00,$00
				defb	$00,$00
				defb	$1F,$08
				defb	$1A,$09
				defb	$1F,$0A
				defb	$16,$0B
				defb	$1F,$0B
				defb	$0D,$0A
				defb	$1F,$09
				defb	$0D,$07
				defb	$00,$00
				defb	$00,$00
				defb	$1F,$06
				defb	$1A,$07
				defb	$1F,$08
				defb	$16,$08
				defb	$1F,$07
				defb	$0D,$06
				defb	$1F,$05
				defb	$FF
		
;Frigoababol		
._efecto10		defb 	$25,$1C
				defb 	$30,$2E
				defb	$00,$00
				defb	$A8,$0A
				defb	$C5,$1A
				defb	$00,$00
				defb	$37,$1C
				defb	$C5,$1C
				defb	$00,$00
				defb	$25,$18
				defb	$30,$26
				defb	$FF
				
; [11] Salto largo
._efecto11		defb	$C3,$0E
				defb	$CC,$0D
				defb	$D5,$0A
				defb	$DE,$06
				defb	$35,$03
				defb	$50,$0B
				defb	$47,$0C
				defb	$3E,$08
				defb	$FF
	
; Msicas:

	; [0] Title
	._song_0
				BINARY "m_title.exo"
	
	; [1] Ingame 1
	._song_1		
				BINARY "m_level_3.exo"
	
	; [2] Ingame 2
	._song_2		
				BINARY "m_level_4.exo"
	
	; [3] Level
	._song_3
				BINARY "m_level.exo"
			
	; [3] Game Over
	._song_4
				BINARY "m_gover.exo"

#endasm

/* 
"Son of a Gun"
(The Vaselines)

Swing swing up and down,
Turn turn turn around,
Round round round and about and over again.
Gun gun son of a gun,
You are the only one, And no one else can take my place.

The sun shines in the bedroom when you play,
And the raining always starts when you go away.
*/
